
// -*- C++ -*-

// (c) COPYRIGHT URI/MIT 1996,2000
// Please read the full copyright statement in the file COPYRIGHT.
//
// Authors:
//      jhrg,jimg       James Gallagher (jgallagher@gso.uri.edu)

// Interface definition for ClientArray. See ClientByte.h for more information
//
// jhrg 1/12/95

#ifndef _ClientArray_h
#define _ClientArray_h 1

#ifdef __GNUG__
#pragma interface
#endif

#include "Array.h"
#include "AttributeInterface.h"
#if 0
#include "AttrTable.h"
#endif

class ClientArray: public Array, public AttributeInterface {
private:
    AttrTable _attr;

public:
    ClientArray(const string &n = (char *)0, BaseType *v = 0);
    virtual ~ClientArray();

    virtual BaseType *ptr_duplicate();

    virtual bool read(const string &dataset, int &error);

    virtual void print_val(ostream &os, string space = "", 
			   bool print_decl_p = true);

    virtual AttrTable &getAttrTable();
    virtual void setAttrTable(AttrTable &attr);
};

// $Log: ClientArray.h,v $
// Revision 1.7.8.2  2000/06/02 23:03:31  jimg
// Fixes for AttrTables with no entries.
// Added support for name translation and a DODS_ML_Real_Name attribute.
// Changed the `size' attribtue's name to DODS_ML_Size.
//
// Revision 1.7.8.1  2000/05/12 19:14:15  jimg
// Now inherits from AttrTable, too
//
// Revision 1.7  1999/04/30 17:06:54  jimg
// Merged with no-gnu and release-2-24
//
// Revision 1.6  1998/09/16 23:02:23  jimg
// Removed write_val() and replaced it with print_val() and print_all_vals()
//
// Revision 1.5  1998/08/03 16:39:44  jimg
// Fixed write_val mfunc so that outermost is no longer used
//
// Revision 1.4  1997/10/04 00:39:59  jimg
// Added changes to support the new deserialize() mfunc and write_val().
//
// Revision 1.3  1996/10/23 23:46:48  jimg
// Modified so that writeval outputs a `recursive' data stream. Thus any
// data type can be written and later read without being flattened. This
// change was made so that the NSCAT data which is represented as a Sequence
// of Structures.
//
// Revision 1.2  1996/10/07 21:00:33  jimg
// Fixed Headers.
//
// Revision 1.1  1996/09/30 23:58:51  jimg
// Added.

#endif

