
// (c) COPYRIGHT URI/MIT 1996
// Please read the full copyright statement in the file COPYRIGH.  
//
// Authors:
//      jhrg,jimg       James Gallagher (jgallagher@gso.uri.edu)

// Implementation for ClientInt32. See ClientByte.cc
//
// jhrg 1/12/95

// $Log: ClientInt32.cc,v $
// Revision 1.14.12.1  2000/06/02 23:03:32  jimg
// Fixes for AttrTables with no entries.
// Added support for name translation and a DODS_ML_Real_Name attribute.
// Changed the `size' attribtue's name to DODS_ML_Size.
//
// Revision 1.14  1999/03/24 06:23:42  brent
// convert String.h to std lib <string>, convert to packages regex -- B^2
//
// Revision 1.13  1998/11/20 08:41:22  jimg
// Fixed the fix for the extra newline separators; it was broken for arrays
//
// Revision 1.12  1998/11/19 20:53:33  jimg
// Fixed the extra newline bug.
//
// Revision 1.11  1998/09/16 23:02:20  jimg
// Removed write_val() and replaced it with print_val() and print_all_vals()
//
// Revision 1.10  1998/08/03 16:39:48  jimg
// Fixed write_val mfunc so that outermost is no longer used
//
// Revision 1.9  1997/10/04 00:40:03  jimg
// Added changes to support the new deserialize() mfunc and write_val().
//
// Revision 1.8  1997/06/06 04:01:44  jimg
// Added ASCII output option to writeval. Uses a global `flag'.
//
// Revision 1.7  1997/04/19 00:54:54  jimg
// Changed ouput stream to simplify reading (for loaddods).
//
// Revision 1.6  1997/02/06 20:43:37  jimg
// Fixed log messages
//
// Revision 1.5  1997/01/10 06:49:32  jimg
// Changed call to name_map::lookup() so that non-alphanumerics are mapped to
// underscore. 
//
// Revision 1.4  1996/11/23 05:12:09  jimg
// Added support for variable renaming via the name_map object.
//
// Revision 1.3  1996/10/23 23:46:40  jimg
// Modified so that writeval outputs a `recursive' data stream. Thus any
// data type can be written and later read without being flattened. This
// change was made so that the NSCAT data which is represented as a Sequence
// of Structures.
//
// Revision 1.2  1996/10/07 21:00:25  jimg
// Fixed Headers.
//
// Revision 1.1  1996/09/30 23:59:09  jimg
// Added.

#ifdef __GNUG__
#pragma implementation
#endif

#include <assert.h>
#include <iostream.h>

#include <Pix.h>
#include <SLList.h>
#include <string>

#include "ClientInt32.h"
#include "name_map.h"

extern name_map names;
extern bool translate;
extern bool ascii;

Int32 *
NewInt32(const string &n)
{
    return new ClientInt32(n);
}

ClientInt32::ClientInt32(const string &n) : Int32(n)
{
}

BaseType *
ClientInt32::ptr_duplicate()
{
    return new ClientInt32(*this);
}

bool
ClientInt32::read(const string &, int &)
{
    assert(false);
    return false;
}

void 
ClientInt32::print_val(ostream &os, string, bool print_decl_p)
{
    if (print_decl_p)
	os << type_name() << endl << names.lookup(name(), translate) << endl;

    if (translate) {
	dods_float64 df = _buf;
	if (ascii)
	    os << df << " ";
	else
	    os.write((void *)&df, sizeof(dods_float64));
    }
    else {
	if (ascii)
	    os << _buf << " ";
	else
	    os.write((void *)&_buf, sizeof(dods_int32));
    }	
}

AttrTable &
ClientInt32::getAttrTable()
{
    return _attr;
}

void 
ClientInt32::setAttrTable(AttrTable &attr)
{
    _attr = attr;
}
